package jalview.ws.params;

import java.io.IOException;
import java.util.List;

public interface ParamDatastoreI 
{

  public List<WsParamSetI> getPresets();

  public WsParamSetI getPreset(String name);

  public List<ArgumentI> getServiceParameters();

  public boolean presetExists(String name);

  public void deletePreset(String name);

  /**
   * writes or overwrites the record for a modifiable WsParamSetI entry in the datastore.
   * @param presetName
   * @param text
   * @param jobParams
   * may throw an illegal argument RunTimeException if the presetName overwrites an existing, unmodifiable preset.
   */
  public void storePreset(String presetName, String text,
          List<ArgumentI> jobParams);

  public boolean readParamSet(WsParamSetI wsp, java.io.Reader reader)
          throws IOException;

  public boolean writeParamSet(WsParamSetI wsp, java.io.Writer writer)
          throws IOException;

}
