package jalview.ws.params;
/**
 * Interface implemented by classes for maintaining user's parameters in a Jalview session
 * @author JimP
 *
 */
public interface ParamManager
{
  /**
   * 
   * @param name (may be null) select parameter sets with given name
   * @param serviceUrl (may be null) select parameter sets that are applicable for the given URL
   * @param modifiable - if true, return modifiable parameter sets
   * @param unmodifiable - if true, return server presets
   * @return null if no parameters found, or one or more parameter sets
   */
  public abstract WsParamSetI[] getParameterSet(String name, String serviceUrl, boolean modifiable,boolean unmodifiable);
  

}
